=== debian/changelog ===
web-eid (2.6.0.654-2004) unstable; urgency=medium

  * Release: 2.6.0.654.

 -- RIA <info@ria.ee>  Thu, 05 Sep 2024 13:18:55 +0300

web-eid (0.0.1) stable; urgency=low

  * Initial release

 -- RIA <info@ria.ee>  Mon, 16 Mar 2020 11:22:56 +0200
