=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_builddeb:
	dh_builddeb -- -Zgzip

override_dh_auto_configure:
	dh_auto_configure -- -DBUNDLE_XPI=ON
